@echo off
rem   $Id: cm_pxe.cmd,v 1.4 2007-05-14 11:09:26 pl Exp $
rem
rem	This utility is a no-brainer ComputeMode Windows agent.
rem	It will be called on a regular basis (every 5 mn for instance)
rem	on the client Windows machines, through a dedicated scheduled task.
rem
rem	It should NOT be called when the user is busy on the machine.
rem
rem	A connection to the ComputeMode server will be done, requesting which
rem	action should be performed. If Computation Mode is required, the PC
rem	will be rebooted and eventually proceed into computation upon server
rem	control.
rem
rem	NOTE: If the 'MAC' environment variable is set, it will be used instead
rem	of probing the installed hardware.
rem
rem	This utility is part of the ComputeMode (R) project.
rem
rem   This utility requires the following programs to be installed in the same
rem   directory or, at your option, in any of the directories included in the
rem   administrator's PATH environment variable:
rem         rb.exe
rem         wget.exe
rem
rem   (c) 2004-2007 Icatis

rem REPLACE this value with the address of the ComputeMode server
set CMSERVER=192.168.7.190

goto START

:START
  if exist stamp date /T && time /T >> stamps

  if not "%1"=="" goto END
  if not "%OS%"=="Windows_NT" goto END

  rem Retrieve current MAC address  

  for /f "tokens=2 delims=:" %%A in ('getmac /FO LIST ^| findstr "Physical Address"') do call :SEARCHMAC "%%A"
  rem echo MAC address: %MAC%

  rem Retrieve command to execute from the CM server
  cm_wget -q -O- "http://%CMSERVER%/cm/engine/automaton.php?mac=%MAC%&bmid=1&event=LocalIdle&os=windows" > %TEMP%.\pxetemp
  type %TEMP%\pxetemp | findstr "<action>BootCM</action>" > NUL
  if not ERRORLEVEL 1 goto :REBOOT
  type %TEMP%\pxetemp | findstr "<action>Shutdown</action>" > NUL
  if ERRORLEVEL 1 goto END

  rem Shutdown
  set STOPPROCESS=shutdown
  cm_rb.exe -l -f -t 100
  goto ASKREBOOTPROCESS

:REBOOT
  rem Let's reboot the machine if required  
  set STOPPROCESS=reboot
  cm_rb.exe -l -r -f -t 100

:ASKREBOOTPROCESS
  rem Ask the user if he wants to stop the reboot/shutdown process
  SET /P CONTINUEPROCESS=Do you want to stop this %STOPPROCESS% process (Y/N) ?
  if /I "%CONTINUEPROCESS%"=="Y" goto STOPREBOOT
  if /I "%CONTINUEPROCESS%"=="N" goto END
  echo. 
  echo.Please answer Y or N
  goto ASKREBOOTPROCESS

:STOPREBOOT
  cm_rb.exe -l -oops
  goto END

:SEARCHMAC
  for %%B in (%~1) do call :ISMAC %%B
  goto:EOF
  
:ISMAC
  echo %1 | findstr "..-..-..-..-..-.." > NUL
  if not ERRORLEVEL 1 call :SETMAC %1
  goto:EOF

:SETMAC
  if "%MAC%"=="" set MAC=%1
  goto:EOF

:END
  set CONTINUEPROCESS=
  set STOPPROCESS=
  del %TEMP%.\pxetemp

